- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- File List
- Globals

# ucol.h File Reference

C API: Collator. More...

`#include "unicode/utypes.h"`
`#include "unicode/unorm.h"`
`#include "unicode/parseerr.h"`
`#include "unicode/uloc.h"`
`#include "unicode/uset.h"`

Go to the source code of this file.

## Defines
#define | U_COL_SAFECLONE_BUFFERSIZE 512
| default memory size for the new clone.
#define | UCOL_SIT_COLLATOR_NOT_ENCODABLE 0x80000000
| Returned by ucol_collatorToIdentifier to signify that collator is not encodable as an identifier.
## Typedefs
typedef UCollator | UCollator
| structure representing a collator object instance
typedef UColAttributeValue | UCollationStrength
| Base letter represents a primary difference.
## Enumerations
enum | UCollationResult { UCOL_EQUAL = 0, UCOL_GREATER = 1, UCOL_LESS = -1 }
| UCOL_LESS is returned if source string is compared to be less than target string in the u_strcoll() method. More...
enum | UColAttributeValue { UCOL_DEFAULT = -1, UCOL_PRIMARY = 0, UCOL_SECONDARY = 1, UCOL_TERTIARY = 2, UCOL_DEFAULT_STRENGTH = UCOL_TERTIARY, UCOL_CE_STRENGTH_LIMIT, UCOL_QUATERNARY = 3, UCOL_IDENTICAL = 15, UCOL_STRENGTH_LIMIT, UCOL_OFF = 16, UCOL_ON = 17, UCOL_SHIFTED = 20, UCOL_NON_IGNORABLE = 21, UCOL_LOWER_FIRST = 24, UCOL_UPPER_FIRST = 25, UCOL_ATTRIBUTE_VALUE_COUNT }
| Enum containing attribute values for controling collation behavior. More...
enum | UColAttribute { UCOL_FRENCH_COLLATION, UCOL_ALTERNATE_HANDLING, UCOL_CASE_FIRST, UCOL_CASE_LEVEL, UCOL_NORMALIZATION_MODE, UCOL_DECOMPOSITION_MODE = UCOL_NORMALIZATION_MODE, UCOL_STRENGTH, UCOL_HIRAGANA_QUATERNARY_MODE, UCOL_NUMERIC_COLLATION, UCOL_ATTRIBUTE_COUNT }
| Attributes that collation service understands. More...
enum | UColRuleOption { UCOL_TAILORING_ONLY, UCOL_FULL_RULES }
| Options for retrieving the rule string. More...
enum | UColBoundMode { UCOL_BOUND_LOWER = 0, UCOL_BOUND_UPPER = 1, UCOL_BOUND_UPPER_LONG = 2, UCOL_BOUND_VALUE_COUNT }
| enum that is taken by ucol_getBound API See below for explanation do not change the values assigned to the members of this enum. More...
## Functions
UCollator * | ucol_open (const char *loc, UErrorCode *status)
| Open a UCollator for comparing strings.
UCollator * | ucol_openRules (const UChar *rules, int32_t rulesLength, UColAttributeValue normalizationMode, UCollationStrength strength, UParseError *parseError, UErrorCode *status)
| Produce an UCollator instance according to the rules supplied.
UCollator * | ucol_openFromShortString (const char *definition, UBool forceDefaults, UParseError *parseError, UErrorCode *status)
| Open a collator defined by a short form string.
int32_t | ucol_getContractions (const UCollator *coll, USet *conts, UErrorCode *status)
| Get a set containing the contractions defined by the collator.
void | ucol_getContractionsAndExpansions (const UCollator *coll, USet *contractions, USet *expansions, UBool addPrefixes, UErrorCode *status)
| Get a set containing the expansions defined by the collator.
void | ucol_close (UCollator *coll)
| Close a UCollator.
UCollationResult | ucol_strcoll (const UCollator *coll, const UChar *source, int32_t sourceLength, const UChar *target, int32_t targetLength)
| Compare two strings.
UBool | ucol_greater (const UCollator *coll, const UChar *source, int32_t sourceLength, const UChar *target, int32_t targetLength)
| Determine if one string is greater than another.
UBool | ucol_greaterOrEqual (const UCollator *coll, const UChar *source, int32_t sourceLength, const UChar *target, int32_t targetLength)
| Determine if one string is greater than or equal to another.
UBool | ucol_equal (const UCollator *coll, const UChar *source, int32_t sourceLength, const UChar *target, int32_t targetLength)
| Compare two strings for equality.
UCollationResult | ucol_strcollIter (const UCollator *coll, UCharIterator *sIter, UCharIterator *tIter, UErrorCode *status)
| Compare two UTF-8 encoded trings.
UCollationStrength | ucol_getStrength (const UCollator *coll)
| Get the collation strength used in a UCollator.
void | ucol_setStrength (UCollator *coll, UCollationStrength strength)
| Set the collation strength used in a UCollator.
int32_t | ucol_getDisplayName (const char *objLoc, const char *dispLoc, UChar *result, int32_t resultLength, UErrorCode *status)
| Get the display name for a UCollator.
const char * | ucol_getAvailable (int32_t index)
| Get a locale for which collation rules are available.
int32_t | ucol_countAvailable (void)
| Determine how many locales have collation rules available.
UEnumeration * | ucol_openAvailableLocales (UErrorCode *status)
| Create a string enumerator of all locales for which a valid collator may be opened.
UEnumeration * | ucol_getKeywords (UErrorCode *status)
| Create a string enumerator of all possible keywords that are relevant to collation.
UEnumeration * | ucol_getKeywordValues (const char *keyword, UErrorCode *status)
| Given a keyword, create a string enumeration of all values for that keyword that are currently in use.
int32_t | ucol_getFunctionalEquivalent (char *result, int32_t resultCapacity, const char *keyword, const char *locale, UBool *isAvailable, UErrorCode *status)
| Return the functionally equivalent locale for the given requested locale, with respect to given keyword, for the collation service.
const UChar * | ucol_getRules (const UCollator *coll, int32_t *length)
| Get the collation rules from a UCollator.
int32_t | ucol_getShortDefinitionString (const UCollator *coll, const char *locale, char *buffer, int32_t capacity, UErrorCode *status)
| Get the short definition string for a collator.
int32_t | ucol_normalizeShortDefinitionString (const char *source, char *destination, int32_t capacity, UParseError *parseError, UErrorCode *status)
| Verifies and normalizes short definition string.
int32_t | ucol_getSortKey (const UCollator *coll, const UChar *source, int32_t sourceLength, uint8_t *result, int32_t resultLength)
| Get a sort key for a string from a UCollator.
int32_t | ucol_nextSortKeyPart (const UCollator *coll, UCharIterator *iter, uint32_t state[2], uint8_t *dest, int32_t count, UErrorCode *status)
| Gets the next count bytes of a sort key.
int32_t | ucol_getBound (const uint8_t *source, int32_t sourceLength, UColBoundMode boundType, uint32_t noOfLevels, uint8_t *result, int32_t resultLength, UErrorCode *status)
| Produce a bound for a given sortkey and a number of levels.
void | ucol_getVersion (const UCollator *coll, UVersionInfo info)
| Gets the version information for a Collator.
void | ucol_getUCAVersion (const UCollator *coll, UVersionInfo info)
| Gets the UCA version information for a Collator.
int32_t | ucol_mergeSortkeys (const uint8_t *src1, int32_t src1Length, const uint8_t *src2, int32_t src2Length, uint8_t *dest, int32_t destCapacity)
| Merge two sort keys.
void | ucol_setAttribute (UCollator *coll, UColAttribute attr, UColAttributeValue value, UErrorCode *status)
| Universal attribute setter.
UColAttributeValue | ucol_getAttribute (const UCollator *coll, UColAttribute attr, UErrorCode *status)
| Universal attribute getter.
uint32_t | ucol_setVariableTop (UCollator *coll, const UChar *varTop, int32_t len, UErrorCode *status)
| Variable top is a two byte primary value which causes all the codepoints with primary values that are less or equal than the variable top to be shifted when alternate handling is set to UCOL_SHIFTED.
uint32_t | ucol_getVariableTop (const UCollator *coll, UErrorCode *status)
| Gets the variable top value of a Collator.
void | ucol_restoreVariableTop (UCollator *coll, const uint32_t varTop, UErrorCode *status)
| Sets the variable top to a collation element value supplied.
UCollator * | ucol_safeClone (const UCollator *coll, void *stackBuffer, int32_t *pBufferSize, UErrorCode *status)
| Thread safe cloning operation.
int32_t | ucol_getRulesEx (const UCollator *coll, UColRuleOption delta, UChar *buffer, int32_t bufferLen)
| Returns current rules.
const char * | ucol_getLocale (const UCollator *coll, ULocDataLocaleType type, UErrorCode *status)
| gets the locale name of the collator.
const char * | ucol_getLocaleByType (const UCollator *coll, ULocDataLocaleType type, UErrorCode *status)
| gets the locale name of the collator.
USet * | ucol_getTailoredSet (const UCollator *coll, UErrorCode *status)
| Get an Unicode set that contains all the characters and sequences tailored in this collator.
uint32_t | ucol_collatorToIdentifier (const UCollator *coll, const char *locale, UErrorCode *status)
| Get a 31-bit identifier given a collator.
UCollator * | ucol_openFromIdentifier (uint32_t identifier, UBool forceDefaults, UErrorCode *status)
| Open a collator given a 31-bit identifier.
int32_t | ucol_identifierToShortString (uint32_t identifier, char *buffer, int32_t capacity, UBool forceDefaults, UErrorCode *status)
| Calculate the short definition string given an identifier.
uint32_t | ucol_shortStringToIdentifier (const char *definition, UBool forceDefaults, UErrorCode *status)
| Calculate the identifier given a short definition string.
UColAttributeValue | ucol_getAttributeOrDefault (const UCollator *coll, UColAttribute attr, UErrorCode *status)
| Universal attribute getter that returns UCOL_DEFAULT if the value is default.
UBool | ucol_equals (const UCollator *source, const UCollator *target)
| Check whether two collators are equal.
int32_t | ucol_getUnsafeSet (const UCollator *coll, USet *unsafe, UErrorCode *status)
| Calculates the set of unsafe code points, given a collator.
void | ucol_forgetUCA (void)
| Reset UCA's static pointers.
void | ucol_prepareShortStringOpen (const char *definition, UBool forceDefaults, UParseError *parseError, UErrorCode *status)
| Touches all resources needed for instantiating a collator from a short string definition, thus filling up the cache.
int32_t | ucol_cloneBinary (const UCollator *coll, uint8_t *buffer, int32_t capacity, UErrorCode *status)
| Creates a binary image of a collator.
UCollator * | ucol_openBinary (const uint8_t *bin, int32_t length, const UCollator *base, UErrorCode *status)
| Opens a collator from a collator binary image created using ucol_cloneBinary.

## Detailed Description

C API: Collator.

## Collator C API

The C API for Collator performs locale-sensitive string comparison. You use this service to build searching and sorting routines for natural language text. Important: The ICU collation service has been reimplemented in order to achieve better performance and UCA compliance. For details, see the collation design document.

For more information about the collation service see the users guide.

Collation service provides correct sorting orders for most locales supported in ICU. If specific data for a locale is not available, the orders eventually falls back to the UCA sort order.

Sort ordering may be customized by providing your own set of rules. For more on this subject see the Collation customization section of the users guide.

See also:
  UCollationResult

  UNormalizationMode

  UCollationStrength

  UCollationElements

Definition in file ucol.h.

## Define Documentation

#define U_COL_SAFECLONE_BUFFERSIZE 512

default memory size for the new clone.

It needs to be this large for os/400 large pointers

Stable:
  ICU 2.0

Definition at line 951 of file ucol.h.

#define UCOL_SIT_COLLATOR_NOT_ENCODABLE 0x80000000

Returned by ucol_collatorToIdentifier to signify that collator is not encodable as an identifier.

Internal:
  Do not use. This API is for interal use only. ICU 3.0

Definition at line 1021 of file ucol.h.

## Typedef Documentation

typedef UColAttributeValue UCollationStrength

Base letter represents a primary difference.

Set comparison level to UCOL_PRIMARY to ignore secondary and tertiary differences. Use this to set the strength of a Collator object. Example of primary difference, "abc" < "abd"

Diacritical differences on the same base letter represent a secondary difference. Set comparison level to UCOL_SECONDARY to ignore tertiary differences. Use this to set the strength of a Collator object. Example of secondary difference, "&auml;" >> "a".

Uppercase and lowercase versions of the same character represents a tertiary difference. Set comparison level to UCOL_TERTIARY to include all comparison differences. Use this to set the strength of a Collator object. Example of tertiary difference, "abc" <<< "ABC".

Two characters are considered "identical" when they have the same unicode spellings. UCOL_IDENTICAL. For example, "&auml;" == "&auml;".

UCollationStrength is also used to determine the strength of sort keys generated from UCollator objects These values can be now found in the UColAttributeValue enum.

Stable:
  ICU 2.0

Definition at line 160 of file ucol.h.

typedef struct UCollator UCollator

structure representing a collator object instance

Stable:
  ICU 2.0

Definition at line 60 of file ucol.h.

## Enumeration Type Documentation

enum UColAttribute

Attributes that collation service understands.

All the attributes can take UCOL_DEFAULT value, as well as the values specific to each one.

Stable:
  ICU 2.0

Enumerator:

  UCOL_FRENCH_COLLATION | Attribute for direction of secondary weights - used in French. Acceptable values are UCOL_ON, which results in secondary weights being considered backwards and UCOL_OFF which treats secondary weights in the order they appear.
  UCOL_ALTERNATE_HANDLING | Attribute for handling variable elements. Acceptable values are UCOL_NON_IGNORABLE (default) which treats all the codepoints with non-ignorable primary weights in the same way, and UCOL_SHIFTED which causes codepoints with primary weights that are equal or below the variable top value to be ignored on primary level and moved to the quaternary level.
  UCOL_CASE_FIRST | Controls the ordering of upper and lower case letters. Acceptable values are UCOL_OFF (default), which orders upper and lower case letters in accordance to their tertiary weights, UCOL_UPPER_FIRST which forces upper case letters to sort before lower case letters, and UCOL_LOWER_FIRST which does the opposite.
  UCOL_CASE_LEVEL | Controls whether an extra case level (positioned before the third level) is generated or not. Acceptable values are UCOL_OFF (default), when case level is not generated, and UCOL_ON which causes the case level to be generated. Contents of the case level are affected by the value of UCOL_CASE_FIRST attribute. A simple way to ignore accent differences in a string is to set the strength to UCOL_PRIMARY and enable case level.
  UCOL_NORMALIZATION_MODE | Controls whether the normalization check and necessary normalizations are performed. When set to UCOL_OFF (default) no normalization check is performed. The correctness of the result is guaranteed only if the input data is in so-called FCD form (see users manual for more info). When set to UCOL_ON, an incremental check is performed to see whether the input data is in the FCD form. If the data is not in the FCD form, incremental NFD normalization is performed.
  UCOL_DECOMPOSITION_MODE | An alias for UCOL_NORMALIZATION_MODE attribute.
  UCOL_STRENGTH | The strength attribute. Can be either UCOL_PRIMARY, UCOL_SECONDARY, UCOL_TERTIARY, UCOL_QUATERNARY or UCOL_IDENTICAL. The usual strength for most locales (except Japanese) is tertiary. Quaternary strength is useful when combined with shifted setting for alternate handling attribute and for JIS x 4061 collation, when it is used to distinguish between Katakana and Hiragana (this is achieved by setting the UCOL_HIRAGANA_QUATERNARY mode to on. Otherwise, quaternary level is affected only by the number of non ignorable code points in the string. Identical strength is rarely useful, as it amounts to codepoints of the NFD form of the string.
  UCOL_HIRAGANA_QUATERNARY_MODE | When turned on, this attribute positions Hiragana before all non-ignorables on quaternary level This is a sneaky way to produce JIS sort order.
  UCOL_NUMERIC_COLLATION | When turned on, this attribute generates a collation key for the numeric value of substrings of digits. This is a way to get '100' to sort AFTER '2'.

Definition at line 166 of file ucol.h.

enum UColAttributeValue

Enum containing attribute values for controling collation behavior.

Here are all the allowable values. Not every attribute can take every value. The only universal value is UCOL_DEFAULT, which resets the attribute value to the predefined value for that locale

Stable:
  ICU 2.0

Enumerator:

  UCOL_DEFAULT | accepted by most attributes
  UCOL_PRIMARY | Primary collation strength.
  UCOL_SECONDARY | Secondary collation strength.
  UCOL_TERTIARY | Tertiary collation strength.
  UCOL_DEFAULT_STRENGTH | Default collation strength.
  UCOL_QUATERNARY | Quaternary collation strength.
  UCOL_IDENTICAL | Identical collation strength.
  UCOL_OFF | Turn the feature off - works for UCOL_FRENCH_COLLATION, UCOL_CASE_LEVEL, UCOL_HIRAGANA_QUATERNARY_MODE & UCOL_DECOMPOSITION_MODE.
  UCOL_ON | Turn the feature on - works for UCOL_FRENCH_COLLATION, UCOL_CASE_LEVEL, UCOL_HIRAGANA_QUATERNARY_MODE & UCOL_DECOMPOSITION_MODE.
  UCOL_SHIFTED | Valid for UCOL_ALTERNATE_HANDLING. Alternate handling will be shifted
  UCOL_NON_IGNORABLE | Valid for UCOL_ALTERNATE_HANDLING. Alternate handling will be non ignorable
  UCOL_LOWER_FIRST | Valid for UCOL_CASE_FIRST - lower case sorts before upper case.
  UCOL_UPPER_FIRST | upper case sorts before lower case

Definition at line 91 of file ucol.h.

enum UColBoundMode

enum that is taken by ucol_getBound API See below for explanation do not change the values assigned to the members of this enum.

Underlying code depends on them having these numbers

Stable:
  ICU 2.0

Enumerator:

  UCOL_BOUND_LOWER | lower bound
  UCOL_BOUND_UPPER | upper bound that will match strings of exact size
  UCOL_BOUND_UPPER_LONG | upper bound that will match all the strings that have the same initial substring as the given string

Definition at line 737 of file ucol.h.

enum UCollationResult

UCOL_LESS is returned if source string is compared to be less than target string in the u_strcoll() method.

UCOL_EQUAL is returned if source string is compared to be equal to target string in the u_strcoll() method. UCOL_GREATER is returned if source string is compared to be greater than target string in the u_strcoll() method.

See also:
  u_strcoll()

Possible values for a comparison result

Stable:
  ICU 2.0

Enumerator:

  UCOL_EQUAL | string a == string b
  UCOL_GREATER | string a > string b
  UCOL_LESS | string a < string b

Definition at line 75 of file ucol.h.

enum UColRuleOption

Options for retrieving the rule string.

Stable:
  ICU 2.0

Enumerator:

  UCOL_TAILORING_ONLY | Retrieve tailoring only.
  UCOL_FULL_RULES | Retrieve UCA rules and tailoring.

Definition at line 231 of file ucol.h.

## Function Documentation

int32_t ucol_cloneBinary | ( | const UCollator * | coll,
|  | uint8_t * | buffer,
|  | int32_t | capacity,
|  | UErrorCode * | status |
| ) |  |  |

Creates a binary image of a collator.

This binary image can be stored and later used to instantiate a collator using ucol_openBinary. This API supports preflighting.

Parameters:

  | coll | Collator
  | buffer | a fill-in buffer to receive the binary image
  | capacity | capacity of the destination buffer
  | status | for catching errors

Returns:
  size of the image

See also:
  ucol_openBinary

Stable:
  ICU 3.2

void ucol_close | ( | UCollator * | coll | ) |

Close a UCollator.

Once closed, a UCollator should not be used. Every open collator should be closed. Otherwise, a memory leak will result.

Parameters:

  | coll | The UCollator to close.

See also:
  ucol_open

  ucol_openRules

  ucol_safeClone

Stable:
  ICU 2.0

uint32_t ucol_collatorToIdentifier | ( | const UCollator * | coll,
|  | const char * | locale,
|  | UErrorCode * | status |
| ) |  |  |

Get a 31-bit identifier given a collator.

Parameters:

  | coll | UCollator
  | locale | a locale that will appear as a collators locale in the resulting short string definition. If NULL, the locale will be harvested from the collator.
  | status | holds error messages

Returns:
  31-bit identifier. MSB is used if the collator cannot be encoded. In that case UCOL_SIT_COLLATOR_NOT_ENCODABLE is returned

See also:
  ucol_openFromIdentifier

  ucol_identifierToShortString

Internal:
  Do not use. This API is for interal use only. ICU 3.0

int32_t ucol_countAvailable | ( | void |  | ) |

Determine how many locales have collation rules available.

This function is most useful as determining the loop ending condition for calls to ucol_getAvailable.

Returns:
  The number of locales for which collation rules are available.

See also:
  ucol_getAvailable

Stable:
  ICU 2.0

UBool ucol_equal | ( | const UCollator * | coll,
|  | const UChar * | source,
|  | int32_t | sourceLength,
|  | const UChar * | target,
|  | int32_t | targetLength |
| ) |  |  |

Compare two strings for equality.

This function is equivalent to ucol_strcoll == UCOL_EQUAL

Parameters:

  | coll | The UCollator containing the comparison rules.
  | source | The source string.
  | sourceLength | The length of source, or -1 if null-terminated.
  | target | The target string.
  | targetLength | The length of target, or -1 if null-terminated.

Returns:
  TRUE if source is equal to target, FALSE otherwise

See also:
  ucol_strcoll

  ucol_greater

  ucol_greaterOrEqual

Stable:
  ICU 2.0

UBool ucol_equals | ( | const UCollator * | source,
|  | const UCollator * | target |
| ) |  |  |

Check whether two collators are equal.

Collators are considered equal if they will sort strings the same. This means that both the current attributes and the rules must be equivalent. Currently used for RuleBasedCollator::operator==.

Parameters:

  | source | first collator
  | target | second collator

Returns:
  TRUE or FALSE

Internal:
  Do not use. This API is for interal use only. ICU 3.0

void ucol_forgetUCA | ( | void |  | ) |

Reset UCA's static pointers.

You don't want to use this, unless your static memory can go away.

Internal:
  Do not use. This API is for interal use only. ICU 3.2.1

UColAttributeValue ucol_getAttribute | ( | const UCollator * | coll,
|  | UColAttribute | attr,
|  | UErrorCode * | status |
| ) |  |  |

Universal attribute getter.

Parameters:

  | coll | collator which attributes are to be changed
  | attr | attribute type

Returns:
  attribute value

Parameters:

  | status | to indicate whether the operation went on smoothly or there were errors

See also:
  UColAttribute

  UColAttributeValue

  ucol_setAttribute

Stable:
  ICU 2.0

UColAttributeValue ucol_getAttributeOrDefault | ( | const UCollator * | coll,
|  | UColAttribute | attr,
|  | UErrorCode * | status |
| ) |  |  |

Universal attribute getter that returns UCOL_DEFAULT if the value is default.

Parameters:

  | coll | collator which attributes are to be changed
  | attr | attribute type

Returns:
  attribute value or UCOL_DEFAULT if the value is default

Parameters:

  | status | to indicate whether the operation went on smoothly or there were errors

See also:
  UColAttribute

  UColAttributeValue

  ucol_setAttribute

Internal:
  Do not use. This API is for interal use only. ICU 3.0

const char* ucol_getAvailable | ( | int32_t | index | ) |

Get a locale for which collation rules are available.

A UCollator in a locale returned by this function will perform the correct collation for the locale.

Parameters:

  | index | The index of the desired locale.

Returns:
  A locale for which collation rules are available, or 0 if none.

See also:
  ucol_countAvailable

Stable:
  ICU 2.0

int32_t ucol_getBound | ( | const uint8_t * | source,
|  | int32_t | sourceLength,
|  | UColBoundMode | boundType,
|  | uint32_t | noOfLevels,
|  | uint8_t * | result,
|  | int32_t | resultLength,
|  | UErrorCode * | status |
| ) |  |  |

Produce a bound for a given sortkey and a number of levels.

Return value is always the number of bytes needed, regardless of whether the result buffer was big enough or even valid.
Resulting bounds can be used to produce a range of strings that are between upper and lower bounds. For example, if bounds are produced for a sortkey of string "smith", strings between upper and lower bounds with one level would include "Smith", "SMITH", "sMiTh".
There are two upper bounds that can be produced. If UCOL_BOUND_UPPER is produced, strings matched would be as above. However, if bound produced using UCOL_BOUND_UPPER_LONG is used, the above example will also match "Smithsonian" and similar.
For more on usage, see example in cintltst/capitst.c in procedure TestBounds. Sort keys may be compared using `strcmp`.

Parameters:

  | source | The source sortkey.
  | sourceLength | The length of source, or -1 if null-terminated. (If an unmodified sortkey is passed, it is always null terminated).
  | boundType | Type of bound required. It can be UCOL_BOUND_LOWER, which produces a lower inclusive bound, UCOL_BOUND_UPPER, that produces upper bound that matches strings of the same length or UCOL_BOUND_UPPER_LONG that matches strings that have the same starting substring as the source string.
  | noOfLevels | Number of levels required in the resulting bound (for most uses, the recommended value is 1). See users guide for explanation on number of levels a sortkey can have.
  | result | A pointer to a buffer to receive the resulting sortkey.
  | resultLength | The maximum size of result.
  | status | Used for returning error code if something went wrong. If the number of levels requested is higher than the number of levels in the source key, a warning (U_SORT_KEY_TOO_SHORT_WARNING) is issued.

Returns:
  The size needed to fully store the bound.

See also:
  ucol_keyHashCode

Stable:
  ICU 2.1

int32_t ucol_getContractions | ( | const UCollator * | coll,
|  | USet * | conts,
|  | UErrorCode * | status |
| ) |  |  |

Get a set containing the contractions defined by the collator.

The set includes both the UCA contractions and the contractions defined by the collator. This set will contain only strings. If a tailoring explicitly suppresses contractions from the UCA (like Russian), removed contractions will not be in the resulting set.

Parameters:

  | coll | collator
  | conts | the set to hold the result. It gets emptied before contractions are added.
  | status | to hold the error code

Returns:
  the size of the contraction set

Deprecated:
  ICU 3.4, use ucol_getContractionsAndExpansions instead

void ucol_getContractionsAndExpansions | ( | const UCollator * | coll,
|  | USet * | contractions,
|  | USet * | expansions,
|  | UBool | addPrefixes,
|  | UErrorCode * | status |
| ) |  |  |

Get a set containing the expansions defined by the collator.

The set includes both the UCA expansions and the expansions defined by the tailoring

Parameters:

  | coll | collator
  | contractions | if not NULL, the set to hold the contractions
  | expansions | if not NULL, the set to hold the expansions
  | addPrefixes | add the prefix contextual elements to contractions
  | status | to hold the error code

Stable:
  ICU 3.4

int32_t ucol_getDisplayName | ( | const char * | objLoc,
|  | const char * | dispLoc,
|  | UChar * | result,
|  | int32_t | resultLength,
|  | UErrorCode * | status |
| ) |  |  |

Get the display name for a UCollator.

The display name is suitable for presentation to a user.

Parameters:

  | objLoc | The locale of the collator in question.
  | dispLoc | The locale for display.
  | result | A pointer to a buffer to receive the attribute.
  | resultLength | The maximum size of result.
  | status | A pointer to an UErrorCode to receive any errors

Returns:
  The total buffer size needed; if greater than resultLength, the output was truncated.

Stable:
  ICU 2.0

int32_t ucol_getFunctionalEquivalent | ( | char * | result,
|  | int32_t | resultCapacity,
|  | const char * | keyword,
|  | const char * | locale,
|  | UBool * | isAvailable,
|  | UErrorCode * | status |
| ) |  |  |

Return the functionally equivalent locale for the given requested locale, with respect to given keyword, for the collation service.

If two locales return the same result, then collators instantiated for these locales will behave equivalently. The converse is not always true; two collators may in fact be equivalent, but return different results, due to internal details. The return result has no other meaning than that stated above, and implies nothing as to the relationship between the two locales. This is intended for use by applications who wish to cache collators, or otherwise reuse collators when possible. The functional equivalent may change over time. For more information, please see the Locales and Services section of the ICU User Guide.

Parameters:

  | result | fillin for the functionally equivalent locale
  | resultCapacity | capacity of the fillin buffer
  | keyword | a particular keyword as enumerated by ucol_getKeywords.
  | locale | the requested locale
  | isAvailable | if non-NULL, pointer to a fillin parameter that indicates whether the requested locale was 'available' to the collation service. A locale is defined as 'available' if it physically exists within the collation locale data.
  | status | pointer to input-output error code

Returns:
  the actual buffer size needed for the locale. If greater than resultCapacity, the returned full name will be truncated and an error code will be returned.

Stable:
  ICU 3.0

UEnumeration* ucol_getKeywords | ( | UErrorCode * | status | ) |

Create a string enumerator of all possible keywords that are relevant to collation.

At this point, the only recognized keyword for this service is "collation".

Parameters:

  | status | input-output error code

Returns:
  a string enumeration over locale strings. The caller is responsible for closing the result.

Stable:
  ICU 3.0

UEnumeration* ucol_getKeywordValues | ( | const char * | keyword,
|  | UErrorCode * | status |
| ) |  |  |

Given a keyword, create a string enumeration of all values for that keyword that are currently in use.

Parameters:

  | keyword | a particular keyword as enumerated by ucol_getKeywords. If any other keyword is passed in, *status is set to U_ILLEGAL_ARGUMENT_ERROR.
  | status | input-output error code

Returns:
  a string enumeration over collation keyword values, or NULL upon error. The caller is responsible for closing the result.

Stable:
  ICU 3.0

const char* ucol_getLocale | ( | const UCollator * | coll,
|  | ULocDataLocaleType | type,
|  | UErrorCode * | status |
| ) |  |  |

gets the locale name of the collator.

If the collator is instantiated from the rules, then this function returns NULL.

Parameters:

  | coll | The UCollator for which the locale is needed
  | type | You can choose between requested, valid and actual locale. For description see the definition of ULocDataLocaleType in uloc.h
  | status | error code of the operation

Returns:
  real locale name from which the collation data comes. If the collator was instantiated from rules, returns NULL.

Deprecated:
  ICU 2.8 Use ucol_getLocaleByType instead

const char* ucol_getLocaleByType | ( | const UCollator * | coll,
|  | ULocDataLocaleType | type,
|  | UErrorCode * | status |
| ) |  |  |

gets the locale name of the collator.

If the collator is instantiated from the rules, then this function returns NULL.

Parameters:

  | coll | The UCollator for which the locale is needed
  | type | You can choose between requested, valid and actual locale. For description see the definition of ULocDataLocaleType in uloc.h
  | status | error code of the operation

Returns:
  real locale name from which the collation data comes. If the collator was instantiated from rules, returns NULL.

Stable:
  ICU 2.8

const UChar* ucol_getRules | ( | const UCollator * | coll,
|  | int32_t * | length |
| ) |  |  |

Get the collation rules from a UCollator.

The rules will follow the rule syntax.

Parameters:

  | coll | The UCollator to query.
  | length |

Returns:
  The collation rules.

Stable:
  ICU 2.0

int32_t ucol_getRulesEx | ( | const UCollator * | coll,
|  | UColRuleOption | delta,
|  | UChar * | buffer,
|  | int32_t | bufferLen |
| ) |  |  |

Returns current rules.

Delta defines whether full rules are returned or just the tailoring. Returns number of UChars needed to store rules. If buffer is NULL or bufferLen is not enough to store rules, will store up to available space.

Parameters:

  | coll | collator to get the rules from
  | delta | one of UCOL_TAILORING_ONLY, UCOL_FULL_RULES.
  | buffer | buffer to store the result in. If NULL, you'll get no rules.
  | bufferLen | lenght of buffer to store rules in. If less then needed you'll get only the part that fits in.

Returns:
  current rules

Stable:
  ICU 2.0

int32_t ucol_getShortDefinitionString | ( | const UCollator * | coll,
|  | const char * | locale,
|  | char * | buffer,
|  | int32_t | capacity,
|  | UErrorCode * | status |
| ) |  |  |

Get the short definition string for a collator.

This API harvests the collator's locale and the attribute set and produces a string that can be used for opening a collator with the same properties using the ucol_openFromShortString API. This string will be normalized. The structure and the syntax of the string is defined in the "Naming collators" section of the users guide: http://icu-project.org/userguide/Collate_Concepts.html#Naming_Collators This API supports preflighting.

Parameters:

  | coll | a collator
  | locale | a locale that will appear as a collators locale in the resulting short string definition. If NULL, the locale will be harvested from the collator.
  | buffer | space to hold the resulting string
  | capacity | capacity of the buffer
  | status | for returning errors. All the preflighting errors are featured

Returns:
  length of the resulting string

See also:
  ucol_openFromShortString

  ucol_normalizeShortDefinitionString

Stable:
  ICU 3.0

int32_t ucol_getSortKey | ( | const UCollator * | coll,
|  | const UChar * | source,
|  | int32_t | sourceLength,
|  | uint8_t * | result,
|  | int32_t | resultLength |
| ) |  |  |

Get a sort key for a string from a UCollator.

Sort keys may be compared using `strcmp`.

Parameters:

  | coll | The UCollator containing the collation rules.
  | source | The string to transform.
  | sourceLength | The length of source, or -1 if null-terminated.
  | result | A pointer to a buffer to receive the attribute.
  | resultLength | The maximum size of result.

Returns:
  The size needed to fully store the sort key..

See also:
  ucol_keyHashCode

Stable:
  ICU 2.0

UCollationStrength ucol_getStrength | ( | const UCollator * | coll | ) |

Get the collation strength used in a UCollator.

The strength influences how strings are compared.

Parameters:

  | coll | The UCollator to query.

Returns:
  The collation strength; one of UCOL_PRIMARY, UCOL_SECONDARY, UCOL_TERTIARY, UCOL_QUATERNARY, UCOL_IDENTICAL

See also:
  ucol_setStrength

Stable:
  ICU 2.0

USet* ucol_getTailoredSet | ( | const UCollator * | coll,
|  | UErrorCode * | status |
| ) |  |  |

Get an Unicode set that contains all the characters and sequences tailored in this collator.

The result must be disposed of by using uset_close.

Parameters:

  | coll | The UCollator for which we want to get tailored chars
  | status | error code of the operation

Returns:
  a pointer to newly created USet. Must be be disposed by using uset_close

See also:
  ucol_openRules

  uset_close

Stable:
  ICU 2.4

void ucol_getUCAVersion | ( | const UCollator * | coll,
|  | UVersionInfo | info |
| ) |  |  |

Gets the UCA version information for a Collator.

Version is the UCA version number (3.1.1, 4.0).

Parameters:

  | coll | The UCollator to query.
  | info | the version # information, the result will be filled in

Stable:
  ICU 2.8

int32_t ucol_getUnsafeSet | ( | const UCollator * | coll,
|  | USet * | unsafe,
|  | UErrorCode * | status |
| ) |  |  |

Calculates the set of unsafe code points, given a collator.

A character is unsafe if you could append any character and cause the ordering to alter significantly. Collation sorts in normalized order, so anything that rearranges in normalization can cause this. Thus if you have a character like a_umlaut, and you add a lower_dot to it, then it normalizes to a_lower_dot + umlaut, and sorts differently.

Parameters:

  | coll | Collator
  | unsafe | a fill-in set to receive the unsafe points
  | status | for catching errors

Returns:
  number of elements in the set

Internal:
  Do not use. This API is for interal use only. ICU 3.0

uint32_t ucol_getVariableTop | ( | const UCollator * | coll,
|  | UErrorCode * | status |
| ) |  |  |

Gets the variable top value of a Collator.

Lower 16 bits are undefined and should be ignored.

Parameters:

  | coll | collator which variable top needs to be retrieved
  | status | error code (not changed by function). If error code is set, the return value is undefined.

Returns:
  the variable top value of a Collator.

See also:
  ucol_setVariableTop

  ucol_restoreVariableTop

Stable:
  ICU 2.0

void ucol_getVersion | ( | const UCollator * | coll,
|  | UVersionInfo | info |
| ) |  |  |

Gets the version information for a Collator.

Version is currently an opaque 32-bit number which depends, among other things, on major versions of the collator tailoring and UCA.

Parameters:

  | coll | The UCollator to query.
  | info | the version # information, the result will be filled in

Stable:
  ICU 2.0

UBool ucol_greater | ( | const UCollator * | coll,
|  | const UChar * | source,
|  | int32_t | sourceLength,
|  | const UChar * | target,
|  | int32_t | targetLength |
| ) |  |  |

Determine if one string is greater than another.

This function is equivalent to ucol_strcoll == UCOL_GREATER

Parameters:

  | coll | The UCollator containing the comparison rules.
  | source | The source string.
  | sourceLength | The length of source, or -1 if null-terminated.
  | target | The target string.
  | targetLength | The length of target, or -1 if null-terminated.

Returns:
  TRUE if source is greater than target, FALSE otherwise.

See also:
  ucol_strcoll

  ucol_greaterOrEqual

  ucol_equal

Stable:
  ICU 2.0

UBool ucol_greaterOrEqual | ( | const UCollator * | coll,
|  | const UChar * | source,
|  | int32_t | sourceLength,
|  | const UChar * | target,
|  | int32_t | targetLength |
| ) |  |  |

Determine if one string is greater than or equal to another.

This function is equivalent to ucol_strcoll != UCOL_LESS

Parameters:

  | coll | The UCollator containing the comparison rules.
  | source | The source string.
  | sourceLength | The length of source, or -1 if null-terminated.
  | target | The target string.
  | targetLength | The length of target, or -1 if null-terminated.

Returns:
  TRUE if source is greater than or equal to target, FALSE otherwise.

See also:
  ucol_strcoll

  ucol_greater

  ucol_equal

Stable:
  ICU 2.0

int32_t ucol_identifierToShortString | ( | uint32_t | identifier,
|  | char * | buffer,
|  | int32_t | capacity,
|  | UBool | forceDefaults,
|  | UErrorCode * | status |
| ) |  |  |

Calculate the short definition string given an identifier.

Supports preflighting.

Parameters:

  | identifier | 31-bit identifier, encoded by calling ucol_collatorToIdentifier
  | buffer | buffer to store the result
  | capacity | buffer capacity
  | forceDefaults | whether the settings that are the same as the default setting should be forced anyway. Setting this argument to FALSE reduces the number of different configurations, but decreases performace as a collator has to be instantiated.
  | status | for returning errors

Returns:
  length of the short definition string

See also:
  ucol_collatorToIdentifier

  ucol_openFromIdentifier

  ucol_shortStringToIdentifier

Internal:
  Do not use. This API is for interal use only. ICU 3.0

int32_t ucol_mergeSortkeys | ( | const uint8_t * | src1,
|  | int32_t | src1Length,
|  | const uint8_t * | src2,
|  | int32_t | src2Length,
|  | uint8_t * | dest,
|  | int32_t | destCapacity |
| ) |  |  |

Merge two sort keys.

The levels are merged with their corresponding counterparts (primaries with primaries, secondaries with secondaries etc.). Between the values from the same level a separator is inserted. example (uncompressed): 191B1D 01 050505 01 910505 00 and 1F2123 01 050505 01 910505 00 will be merged as 191B1D 02 1F212301 050505 02 050505 01 910505 02 910505 00 This allows for concatenating of first and last names for sorting, among other things. If the destination buffer is not big enough, the results are undefined. If any of source lengths are zero or any of source pointers are NULL/undefined, result is of size zero.

Parameters:

  | src1 | pointer to the first sortkey
  | src1Length | length of the first sortkey
  | src2 | pointer to the second sortkey
  | src2Length | length of the second sortkey
  | dest | buffer to hold the result
  | destCapacity | size of the buffer for the result

Returns:
  size of the result. If the buffer is big enough size is always src1Length+src2Length-1

Stable:
  ICU 2.0

int32_t ucol_nextSortKeyPart | ( | const UCollator * | coll,
|  | UCharIterator * | iter,
|  | uint32_t | state[2],
|  | uint8_t * | dest,
|  | int32_t | count,
|  | UErrorCode * | status |
| ) |  |  |

Gets the next count bytes of a sort key.

Caller needs to preserve state array between calls and to provide the same type of UCharIterator set with the same string. The destination buffer provided must be big enough to store the number of requested bytes. Generated sortkey is not compatible with sortkeys generated using ucol_getSortKey API, since we don't do any compression. If uncompressed sortkeys are required, this API can be used.

Parameters:

  | coll | The UCollator containing the collation rules.
  | iter | UCharIterator containing the string we need the sort key to be calculated for.
  | state | Opaque state of sortkey iteration.
  | dest | Buffer to hold the resulting sortkey part
  | count | number of sort key bytes required.
  | status | error code indicator.

Returns:
  the actual number of bytes of a sortkey. It can be smaller than count if we have reached the end of the sort key.

Stable:
  ICU 2.6

int32_t ucol_normalizeShortDefinitionString | ( | const char * | source,
|  | char * | destination,
|  | int32_t | capacity,
|  | UParseError * | parseError,
|  | UErrorCode * | status |
| ) |  |  |

Verifies and normalizes short definition string.

Normalized short definition string has all the option sorted by the argument name, so that equivalent definition strings are the same. This API supports preflighting.

Parameters:

  | source | definition string
  | destination | space to hold the resulting string
  | capacity | capacity of the buffer
  | parseError | if not NULL, structure that will get filled with error's pre and post context in case of error.
  | status | Error code. This API will return an error if an invalid attribute or attribute/value combination is specified. All the preflighting errors are also featured

Returns:
  length of the resulting normalized string.

See also:
  ucol_openFromShortString

  ucol_getShortDefinitionString

Stable:
  ICU 3.0

UCollator* ucol_open | ( | const char * | loc,
|  | UErrorCode * | status |
| ) |  |  |

Open a UCollator for comparing strings.

The UCollator pointer is used in all the calls to the Collation service. After finished, collator must be disposed of by calling ucol_close.

Parameters:

  | loc | The locale containing the required collation rules. Special values for locales can be passed in - if NULL is passed for the locale, the default locale collation rules will be used. If empty string ("") or "root" are passed, UCA rules will be used.
  | status | A pointer to an UErrorCode to receive any errors

Returns:
  A pointer to a UCollator, or 0 if an error occurred.

See also:
  ucol_openRules

  ucol_safeClone

  ucol_close

Stable:
  ICU 2.0

UEnumeration* ucol_openAvailableLocales | ( | UErrorCode * | status | ) |

Create a string enumerator of all locales for which a valid collator may be opened.

Parameters:

  | status | input-output error code

Returns:
  a string enumeration over locale strings. The caller is responsible for closing the result.

Stable:
  ICU 3.0

UCollator* ucol_openBinary | ( | const uint8_t * | bin,
|  | int32_t | length,
|  | const UCollator * | base,
|  | UErrorCode * | status |
| ) |  |  |

Opens a collator from a collator binary image created using ucol_cloneBinary.

Binary image used in instantiation of the collator remains owned by the user and should stay around for the lifetime of the collator. The API also takes a base collator which usualy should be UCA.

Parameters:

  | bin | binary image owned by the user and required through the lifetime of the collator
  | length | size of the image. If negative, the API will try to figure out the length of the image
  | base | fallback collator, usually UCA. Base is required to be present through the lifetime of the collator. Currently it cannot be NULL.
  | status | for catching errors

Returns:
  newly created collator

See also:
  ucol_cloneBinary

Stable:
  ICU 3.2

UCollator* ucol_openFromIdentifier | ( | uint32_t | identifier,
|  | UBool | forceDefaults,
|  | UErrorCode * | status |
| ) |  |  |

Open a collator given a 31-bit identifier.

Parameters:

  | identifier | 31-bit identifier, encoded by calling ucol_collatorToIdentifier
  | forceDefaults | if FALSE, the settings that are the same as the collator default settings will not be applied (for example, setting French secondary on a French collator would not be executed). If TRUE, all the settings will be applied regardless of the collator default value. If the definition strings that can be produced from a collator instantiated by calling this API are to be cached, should be set to FALSE.
  | status | for returning errors

Returns:
  UCollator object

See also:
  ucol_collatorToIdentifier

  ucol_identifierToShortString

Internal:
  Do not use. This API is for interal use only. ICU 3.0

UCollator* ucol_openFromShortString | ( | const char * | definition,
|  | UBool | forceDefaults,
|  | UParseError * | parseError,
|  | UErrorCode * | status |
| ) |  |  |

Open a collator defined by a short form string.

The structure and the syntax of the string is defined in the "Naming collators" section of the users guide: http://icu-project.org/userguide/Collate_Concepts.html#Naming_Collators Attributes are overriden by the subsequent attributes. So, for "S2_S3", final strength will be 3. 3066bis locale overrides individual locale parts. The call to this function is equivalent to a call to ucol_open, followed by a series of calls to ucol_setAttribute and ucol_setVariableTop.

Parameters:

  | definition | A short string containing a locale and a set of attributes. Attributes not explicitly mentioned are left at the default state for a locale.
  | parseError | if not NULL, structure that will get filled with error's pre and post context in case of error.
  | forceDefaults | if FALSE, the settings that are the same as the collator default settings will not be applied (for example, setting French secondary on a French collator would not be executed). If TRUE, all the settings will be applied regardless of the collator default value. If the definition strings are to be cached, should be set to FALSE.
  | status | Error code. Apart from regular error conditions connected to instantiating collators (like out of memory or similar), this API will return an error if an invalid attribute or attribute/value combination is specified.

Returns:
  A pointer to a UCollator or 0 if an error occured (including an invalid attribute).

See also:
  ucol_open

  ucol_setAttribute

  ucol_setVariableTop

  ucol_getShortDefinitionString

  ucol_normalizeShortDefinitionString

Stable:
  ICU 3.0

UCollator* ucol_openRules | ( | const UChar * | rules,
|  | int32_t | rulesLength,
|  | UColAttributeValue | normalizationMode,
|  | UCollationStrength | strength,
|  | UParseError * | parseError,
|  | UErrorCode * | status |
| ) |  |  |

Produce an UCollator instance according to the rules supplied.

The rules are used to change the default ordering, defined in the UCA in a process called tailoring. The resulting UCollator pointer can be used in the same way as the one obtained by ucol_strcoll.

Parameters:

  | rules | A string describing the collation rules. For the syntax of the rules please see users guide.
  | rulesLength | The length of rules, or -1 if null-terminated.
  | normalizationMode | The normalization mode: One of UCOL_OFF (expect the text to not need normalization), UCOL_ON (normalize), or UCOL_DEFAULT (set the mode according to the rules)
  | strength | The default collation strength; one of UCOL_PRIMARY, UCOL_SECONDARY, UCOL_TERTIARY, UCOL_IDENTICAL,UCOL_DEFAULT_STRENGTH - can be also set in the rules.
  | parseError | A pointer to UParseError to recieve information about errors occurred during parsing. This argument can currently be set to NULL, but at users own risk. Please provide a real structure.
  | status | A pointer to an UErrorCode to receive any errors

Returns:
  A pointer to a UCollator. It is not guaranteed that NULL be returned in case of error - please use status argument to check for errors.

See also:
  ucol_open

  ucol_safeClone

  ucol_close

Stable:
  ICU 2.0

void ucol_prepareShortStringOpen | ( | const char * | definition,
|  | UBool | forceDefaults,
|  | UParseError * | parseError,
|  | UErrorCode * | status |
| ) |  |  |

Touches all resources needed for instantiating a collator from a short string definition, thus filling up the cache.

Parameters:

  | definition | A short string containing a locale and a set of attributes. Attributes not explicitly mentioned are left at the default state for a locale.
  | parseError | if not NULL, structure that will get filled with error's pre and post context in case of error.
  | forceDefaults | if FALSE, the settings that are the same as the collator default settings will not be applied (for example, setting French secondary on a French collator would not be executed). If TRUE, all the settings will be applied regardless of the collator default value. If the definition strings are to be cached, should be set to FALSE.
  | status | Error code. Apart from regular error conditions connected to instantiating collators (like out of memory or similar), this API will return an error if an invalid attribute or attribute/value combination is specified.

See also:
  ucol_openFromShortString

Internal:
  Do not use. This API is for interal use only. ICU 3.2.1

void ucol_restoreVariableTop | ( | UCollator * | coll,
|  | const uint32_t | varTop,
|  | UErrorCode * | status |
| ) |  |  |

Sets the variable top to a collation element value supplied.

Variable top is set to the upper 16 bits. Lower 16 bits are ignored.

Parameters:

  | coll | collator which variable top needs to be changed
  | varTop | CE value, as returned by ucol_setVariableTop or ucol)getVariableTop
  | status | error code (not changed by function)

See also:
  ucol_getVariableTop

  ucol_setVariableTop

Stable:
  ICU 2.0

UCollator* ucol_safeClone | ( | const UCollator * | coll,
|  | void * | stackBuffer,
|  | int32_t * | pBufferSize,
|  | UErrorCode * | status |
| ) |  |  |

Thread safe cloning operation.

The result is a clone of a given collator.

Parameters:

  | coll | collator to be cloned
  | stackBuffer | user allocated space for the new clone. If NULL new memory will be allocated. If buffer is not large enough, new memory will be allocated. Clients can use the U_COL_SAFECLONE_BUFFERSIZE. This will probably be enough to avoid memory allocations.
  | pBufferSize | pointer to size of allocated space. If *pBufferSize == 0, a sufficient size for use in cloning will be returned ('pre-flighting') If *pBufferSize is not enough for a stack-based safe clone, new memory will be allocated.
  | status | to indicate whether the operation went on smoothly or there were errors An informational status value, U_SAFECLONE_ALLOCATED_ERROR, is used if any allocations were necessary.

Returns:
  pointer to the new clone

See also:
  ucol_open

  ucol_openRules

  ucol_close

Stable:
  ICU 2.0

void ucol_setAttribute | ( | UCollator * | coll,
|  | UColAttribute | attr,
|  | UColAttributeValue | value,
|  | UErrorCode * | status |
| ) |  |  |

Universal attribute setter.

Parameters:

  | coll | collator which attributes are to be changed
  | attr | attribute type
  | value | attribute value
  | status | to indicate whether the operation went on smoothly or there were errors

See also:
  UColAttribute

  UColAttributeValue

  ucol_getAttribute

Stable:
  ICU 2.0

void ucol_setStrength | ( | UCollator * | coll,
|  | UCollationStrength | strength |
| ) |  |  |

Set the collation strength used in a UCollator.

The strength influences how strings are compared.

Parameters:

  | coll | The UCollator to set.
  | strength | The desired collation strength; one of UCOL_PRIMARY, UCOL_SECONDARY, UCOL_TERTIARY, UCOL_QUATERNARY, UCOL_IDENTICAL, UCOL_DEFAULT

See also:
  ucol_getStrength

Stable:
  ICU 2.0

uint32_t ucol_setVariableTop | ( | UCollator * | coll,
|  | const UChar * | varTop,
|  | int32_t | len,
|  | UErrorCode * | status |
| ) |  |  |

Variable top is a two byte primary value which causes all the codepoints with primary values that are less or equal than the variable top to be shifted when alternate handling is set to UCOL_SHIFTED.

Sets the variable top to a collation element value of a string supplied.

Parameters:

  | coll | collator which variable top needs to be changed
  | varTop | one or more (if contraction) UChars to which the variable top should be set
  | len | length of variable top string. If -1 it is considered to be zero terminated.
  | status | error code. If error code is set, the return value is undefined. Errors set by this function are: U_CE_NOT_FOUND_ERROR if more than one character was passed and there is no such a contraction U_PRIMARY_TOO_LONG_ERROR if the primary for the variable top has more than two bytes

Returns:
  a 32 bit value containing the value of the variable top in upper 16 bits. Lower 16 bits are undefined

See also:
  ucol_getVariableTop

  ucol_restoreVariableTop

Stable:
  ICU 2.0

uint32_t ucol_shortStringToIdentifier | ( | const char * | definition,
|  | UBool | forceDefaults,
|  | UErrorCode * | status |
| ) |  |  |

Calculate the identifier given a short definition string.

Supports preflighting.

Parameters:

  | definition | short string definition
  | forceDefaults | whether the settings that are the same as the default setting should be forced anyway. Setting this argument to FALSE reduces the number of different configurations, but decreases performace as a collator has to be instantiated.
  | status | for returning errors

Returns:
  identifier

See also:
  ucol_collatorToIdentifier

  ucol_openFromIdentifier

  ucol_identifierToShortString

Internal:
  Do not use. This API is for interal use only. ICU 3.0

UCollationResult ucol_strcoll | ( | const UCollator * | coll,
|  | const UChar * | source,
|  | int32_t | sourceLength,
|  | const UChar * | target,
|  | int32_t | targetLength |
| ) |  |  |

Compare two strings.

The strings will be compared using the options already specified.

Parameters:

  | coll | The UCollator containing the comparison rules.
  | source | The source string.
  | sourceLength | The length of source, or -1 if null-terminated.
  | target | The target string.
  | targetLength | The length of target, or -1 if null-terminated.

Returns:
  The result of comparing the strings; one of UCOL_EQUAL, UCOL_GREATER, UCOL_LESS

See also:
  ucol_greater

  ucol_greaterOrEqual

  ucol_equal

Stable:
  ICU 2.0

UCollationResult ucol_strcollIter | ( | const UCollator * | coll,
|  | UCharIterator * | sIter,
|  | UCharIterator * | tIter,
|  | UErrorCode * | status |
| ) |  |  |

Compare two UTF-8 encoded trings.

The strings will be compared using the options already specified.

Parameters:

  | coll | The UCollator containing the comparison rules.
  | sIter | The source string iterator.
  | tIter | The target string iterator.

Returns:
  The result of comparing the strings; one of UCOL_EQUAL, UCOL_GREATER, UCOL_LESS

Parameters:

  | status | A pointer to an UErrorCode to receive any errors

See also:
  ucol_strcoll

Stable:
  ICU 2.6